/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_TRPCLAT4CAN_H
#define IMPL_TYPE_TRPCLAT4CAN_H

#include <cfloat>
#include <cmath>
#include "impl_type_uint8.h"
#include "impl_type_float.h"

struct TRPCLat4CAN {
    ::UInt8 Lat_OP_EPSRoadWheelReqSts{ 0U };
    ::Float Lat_OP_EPSRoadWheelReqValue{ 0.0F };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(Lat_OP_EPSRoadWheelReqSts);
        fun(Lat_OP_EPSRoadWheelReqValue);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(Lat_OP_EPSRoadWheelReqSts);
        fun(Lat_OP_EPSRoadWheelReqValue);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("Lat_OP_EPSRoadWheelReqSts", Lat_OP_EPSRoadWheelReqSts);
        fun("Lat_OP_EPSRoadWheelReqValue", Lat_OP_EPSRoadWheelReqValue);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("Lat_OP_EPSRoadWheelReqSts", Lat_OP_EPSRoadWheelReqSts);
        fun("Lat_OP_EPSRoadWheelReqValue", Lat_OP_EPSRoadWheelReqValue);
    }

    friend bool operator==(const ::TRPCLat4CAN& lhs, const ::TRPCLat4CAN& rhs) noexcept
    {
        return (lhs.Lat_OP_EPSRoadWheelReqSts == rhs.Lat_OP_EPSRoadWheelReqSts) && (fabs(static_cast<double>(lhs.Lat_OP_EPSRoadWheelReqValue - rhs.Lat_OP_EPSRoadWheelReqValue)) < DBL_EPSILON);
    }
};


#endif // IMPL_TYPE_TRPCLAT4CAN_H
